#include "FallingBlock.h"

//	^CCubN̔zu
void TimeLine::assign( vector<vector<BlockType>>& _fieldData ){
	int height = _fieldData.size();
	int x = location;
	for( int i=0 ; i < height ; ++i ){
		BlockType& t = _fieldData.at(i).at(x);
		if( ! isPuzzleBlock( t ) )
			t = TIMELINE;
	}
}

//	m
void FallingBlock::initialize( const Liner2<int>& _area , const Liner2<int>& _coordinates , const vector<int>& _graphHandles ) {
	//	O
	try{
		string s = "FallingBlock::initialize AvO}[̕ցB\n";
		if( _area.x <= 0 || _area.y <= 0 ){
			s += "w肵L̐ɂȂĂ܂B\n\n(߄t߁G) <yn";
			throw s;
		}
		BlockType t = count;
		if( int(_graphHandles.size()) < t ){
			s +=  "^ꂽ摜nh܂B\n\n(R߄t)摜ڸ";
			throw s;
		}
	}
	catch( const string& _s ){
		MessageBox( NULL , _s.c_str() , "G[" , MB_OK );
		exit( -1 );
	}

	//	eϐ
	mainBGMHandle = LoadSoundMem( "Data/mainBGM.ogg" );
	myGameArea = _area;
	myBlocks.reserve( myGameArea.x * myGameArea.y );
	myCoordinates = _coordinates;
	myBlockSetting.myGraphHandles = _graphHandles;
	myGameFieldData.clear();
	myGameFieldGraphData.clear();
	myGameFieldData.resize( myGameArea.y );
	myGameFieldGraphData.resize( myGameArea.y );
	int cellSizeX , cellSizeY;
	GetGraphSize( _graphHandles.at(0) , &cellSizeX , &cellSizeY );
	gameFieldRightDown.x = myCoordinates.x + myGameArea.x * cellSizeX;
	gameFieldRightDown.y = myCoordinates.y + myGameArea.y * cellSizeY;
	roundVanishBlocks = 0;
	isInOperation = true;
	isInGameOver = false;
	isInClear = false;
	isSetBackGraph = false;
	statusInfo.clear();
	statusInfo.push_back( DEFAULT_TIME_LIMIT );		//TIME_VALUE
	statusInfo.push_back( 0 );						//DISTANCE_VALUE
	statusInfo.push_back( 0 );						//BLOCKS_VALUE
	statusInfo.push_back( 0 );						//EFFICIENCY_VALUE
	statusInfo.push_back( DEFAULT_TIME_LIMIT );		//TIME_MAX_VALUE
	statusInfo.push_back( DEFAULT_GOAL_DISTANCE );	//DISTANCE_MAX_VALUE

	for ( int i=0 ; i < myGameArea.y ; ++i ){
		myGameFieldData.at(i).resize( myGameArea.x );
		myGameFieldGraphData.at(i).resize( myGameArea.x );
	}

	//	Q[tB[h̏
	Liner2<int> statusLeftUp( (myCoordinates.x + myGameArea.x * cellSizeX + STATUS_BLANK) , myCoordinates.y );
	Liner2<int> statusRightDown( (statusLeftUp.x + STATUS_WIDTH + STATUS_BLANK ) , (myCoordinates.y + myGameArea.y * cellSizeY ) );
	myGameField.initialize( _graphHandles.at(0) , myGameArea , myCoordinates );
	processingGroup.initialize( myGameArea );
	piledBlock.initialize( myGameArea );
	timeLine.initialize( DEFAULT_TIMELINE_MOVE_INTERBAL , myGameArea );
	statusWindow.initialize( statusLeftUp , statusRightDown - statusLeftUp );
	blackGraph.set( "Data/black.bmp" );
	blackGraph.setCoordinates( myCoordinates );

	//	ubNQ\ɔzu
	Liner2<int> loc ; loc.x = myGameArea.x/2 ; loc.y = 0 ;
	processingGroup.set( getRandomGroupPattern() , DEFAULT_FALL_INTERBAL );

	ChangeVolumeSoundMem( BGM_VOLUME , mainBGMHandle );
	PlaySoundMem( mainBGMHandle , DX_PLAYTYPE_LOOP , true );
}


//	m`
void FallingBlock::draw(){

	//	tB[hf[^̏
	for( int i=0 ; i < BENCH_HEIGHT ; ++i ){
		for( int j=0 ; j < myGameArea.x ; ++j )
			myGameFieldData[i][j] = BENCHGROUND;
	}
	for( int i = BENCH_HEIGHT ; i < myGameArea.y ; ++i ){
		for( int j=0 ; j < myGameArea.x ; ++j )
			myGameFieldData[i][j] = BACKGROUND;
	}

	//	eIuWFNgtB[hf[^ɔzu
	processingGroup.assign( myGameFieldData );
	piledBlock.assign( myGameFieldData );
	timeLine.assign( myGameFieldData );
	
	//	tB[hf[^摜nhɕϊ
	for( int i=0 ; i < myGameArea.y ; ++i ){
		for( int j=0 ; j < myGameArea.x ; ++j ){
			myGameFieldGraphData.at(i).at(j) = myBlockSetting.typeToGraph( myGameFieldData.at(i).at(j) );
		}
	}
			
	//	tB[h̕`
	//wi摜
	if( isSetBackGraph ){ DrawGraph( 0,0, backGraphHandle , true ); }
	//h
	GraphForm::setBlend( DX_BLENDMODE_ALPHA , ALPHA_BLEND_PALAMETER );
	blackGraph.extendTo( gameFieldRightDown );
	blackGraph.draw();
	GraphForm::setBlend( DX_BLENDMODE_NOBLEND , 0 );
	//Q[tB[h
	myGameField.changeField( myGameFieldGraphData );
	myGameField.draw();
	//Xe[^XEBhE
	statusWindow.draw();
}


//	mvZ
void FallingBlock::update(){
	if( isInOperation ){
		//~ubN
		processingGroup.move( myGameFieldData );
	
		//ςubN
		piledBlock.add( processingGroup.getLand() );
		piledBlock.update();
		bool haveSquare = piledBlock.haveSquareInLine( timeLine.location );
		int location = timeLine.move( haveSquare );
		roundVanishBlocks += piledBlock.erase( location );
	}

	//Xe[^XEBhE
	if( timeLine.isRounded() ){
		--statusInfo.at( TIME_VALUE );
		statusInfo.at( BLOCKS_VALUE ) = roundVanishBlocks;
		statusInfo.at( EFFICIENCY_VALUE ) = timeLine.getEfficiency();
		statusInfo.at( DISTANCE_VALUE ) += ( statusInfo.at( BLOCKS_VALUE ) + statusInfo.at( EFFICIENCY_VALUE ) );
		roundVanishBlocks = 0;
	}
	statusWindow.setInfo( statusInfo );
	
	//	NA
	if( statusInfo.at( DISTANCE_VALUE ) >= statusInfo.at( DISTANCE_MAX_VALUE ) ){
		isInClear = true;
	}

	//	Q[I[o[
	if( piledBlock.checkGameOver() || statusInfo.at( TIME_VALUE ) <= 0 ){
		draw();
		isInOperation = false;
		isInGameOver = true;
	}
}


//	wi摜̃Zbg
void FallingBlock::setBackGraph( int _handle ){
	backGraphHandle = _handle;
	isSetBackGraph = true;
}



//	Q[I[o[ȂtrueԂ
bool FallingBlock::checkGameOver(){
	if( isInGameOver ){ 
		StopSoundMem( mainBGMHandle );
	}
	return isInGameOver;
}


//	NAtrue
bool FallingBlock::isCleared(){
	if( isInClear ){
		StopSoundMem( mainBGMHandle );
	}
	return isInClear;
}

//	ÓIoϐ
vector<int> Block::myGraphHandles;
vector<vector<BlockType>>BlockGroup::groupPattern;
Liner2<int> BlockGroup::startLocation;