//	vOXo[
//	Drawable/DrawableGroup/ProgressBar

#pragma once
#include "drawableGroup.h"
#include "graphForm.h"

class ProgressBar : public DrawableGroup {
protected:
	GraphForm barBack;
	GraphForm barFront;
	Liner2<int> size;
	int valueMax;
	int value;
public:
	
	//ftHg
	ProgressBar(){
		valueMax = 2;
		value = 1;
	}

	//
	virtual void initialize( int _barBackGraph , int _barFrontGraph , Liner2<int> _size ){
		barBack.set( _barBackGraph );
		barFront.set( _barFrontGraph );
		size = _size;
		clear();
		add( barBack );
		add( barFront );
	}
	virtual void initialize( char* _barBack , char* _barFront , Liner2<int> _size ){
		int barBack = LoadGraph( _barBack );
		int barFront = LoadGraph( _barFront );
		initialize( barBack , barFront , _size );
	}

	//lZbg
	virtual void setValue( int _value , int _valueMax ){
		valueMax = _valueMax;
		value = _value;
	}

	//`
	virtual void draw(){
		Liner2<int> backRightDown;
		Liner2<int> frontRightDown;
		backRightDown = coordinates + size;
		frontRightDown.y = backRightDown.y;
		if( valueMax != 0 ){
			frontRightDown.x = coordinates.x + int( double(size.x) * ( double(value) / double(valueMax) ) );
		}
		else{
			frontRightDown.x = backRightDown.x;
		}
		barBack.setCoordinates( coordinates );
		barFront.setCoordinates( coordinates );
		barBack.extendTo( backRightDown );
		barFront.extendTo( frontRightDown );
		drawAll();

	}

	//傫Zbg
	virtual void setSize( Liner2<int> _size ){
		size = _size;
	}
	virtual void setSize( int _x , int _y ){
		Liner2<int> size( _x , _y );
		setSize( size );
	}

	
};