#include "block.h"

//	ubNzɔzu
void Block::assign( vector<vector<BlockType>>& fieldData ){
		fieldData[ myLocation.y ][ myLocation.x ] = myType;
	}


//	^Cvnh
int Block::typeToGraph( const BlockType& _type ){
	return myGraphHandles.at( int(_type) );
}


//	ڒnĂ邩
bool Block::checkLanding( const vector<vector<BlockType>>& gameFieldData ) {
	if( myLocation.y >= int(gameFieldData.size())-1 )
		return true;
	else{
		BlockType down = gameFieldData.at(myLocation.y +1).at(myLocation.x);
		//if( down != 0 && down != 1 )
		if( isPuzzleBlock( down ) )
			return true;
	}
	return false;
}


//	Eɓ]n邩
bool Block::canGoRight( const vector<vector<BlockType>>& gameFieldData ){
	if( myLocation.x >= int(gameFieldData.at(0).size()) - 1 )
		return false;
	else{
		BlockType right = gameFieldData.at(myLocation.y).at(myLocation.x +1);
		if( isPuzzleBlock( right ) )
			return false;
	}
	return true;
}


//	ɓ]n邩
bool Block::canGoLeft( const vector<vector<BlockType>>& gameFieldData ){
	if( myLocation.x <= 0 )
		return false;
	else{
		BlockType left = gameFieldData.at(myLocation.y).at(myLocation.x -1);
		if( isPuzzleBlock( left ) )
			return false;
	}
	return true;
}


//	_blƓF̃ubN
bool Block::isSameColorAs( const Block& _bl ){
	BlockType type1 = myType;
	BlockType type2 = _bl.myType;
	if( type1 == BLOCK_A || type1 == SQUARE_A ){
		if( type2 == BLOCK_A || type2 == SQUARE_A )
			return true;
		else if( type2 == BLOCK_B || type2 == SQUARE_B )
			return false;
	}
	else if( type1 == BLOCK_B || type1 == SQUARE_B ){
		if( type2 == BLOCK_A || type2 == SQUARE_A )
			return false;
		else if( type2 == BLOCK_B || type2 == SQUARE_B )
			return true;
	}
	return false;
}


//	^CvpYubNۂ𔻒f
bool isPuzzleBlock( BlockType t ){
		switch( t ){
		//	͗lubN
		case BACKGROUND:
		case BENCHGROUND:
		case TIMELINE:
			return false;
			break;
		//	pYubN
		case BLOCK_A:
		case BLOCK_B:
		case SQUARE_A:
		case SQUARE_B:
			return true;
			break;
	}
	return false;
}