#include "blockGroup.h"

//	**notice**
//	ubNQ͍ォ玞v0,1,2,3.	͕ȂB

//	ubNQ
void BlockGroup::initialize( const Liner2<int>& _area ){
	//	ϐZbg
	landSoundHandle = LoadSoundMem( "Data/land.wav" );
	isLand = false;
	landingTime = 0;
	startLocation.x = _area.x / 2;
	startLocation.y = 0;
	blocks.clear();
	groupPattern.clear();

	//	ubNp^[̐ݒ
	groupPattern.resize(GROUP_PATTERN_MAX);
	for( int i=0 ; i < GROUP_PATTERN_MAX ; ++i )
		groupPattern[i].resize( GROUP_NUMBER_OF_ELEMENT );
	groupPattern[0][0] = BLOCK_B ; groupPattern[0][1] = BLOCK_B ; groupPattern[0][2] = BLOCK_A ; groupPattern[0][3] = BLOCK_A ;
	groupPattern[1][0] = BLOCK_B ; groupPattern[1][1] = BLOCK_B ; groupPattern[1][2] = BLOCK_B ; groupPattern[1][3] = BLOCK_B ;
	groupPattern[2][0] = BLOCK_A ; groupPattern[2][1] = BLOCK_A ; groupPattern[2][2] = BLOCK_A ; groupPattern[2][3] = BLOCK_A ;
	groupPattern[3][0] = BLOCK_B ; groupPattern[3][1] = BLOCK_A ; groupPattern[3][2] = BLOCK_B ; groupPattern[3][3] = BLOCK_A ;
	groupPattern[4][0] = BLOCK_B ; groupPattern[4][1] = BLOCK_B ; groupPattern[4][2] = BLOCK_B ; groupPattern[4][3] = BLOCK_A ;
	groupPattern[5][0] = BLOCK_B ; groupPattern[5][1] = BLOCK_A ; groupPattern[5][2] = BLOCK_A ; groupPattern[5][3] = BLOCK_A ;
}


//	ubNQ̃Zbg
void BlockGroup::set( const int& _pattern , const int& _fallInterbal ){
	//	oϐ̃Zbg
	location = startLocation;
	fallInterbal = _fallInterbal;
	time = 0;
	landingTime = 0;
	isLand = false;
	isFallingFast = false;

	//	ubN̉
	blocks.resize( GROUP_NUMBER_OF_ELEMENT );
	for( int i=0 ; i < GROUP_NUMBER_OF_ELEMENT ; ++i ){
		blocks[i].myType = groupPattern[ _pattern ][ i ];
	}

	//	_ȉ񐔃ubN]
	int times = GetRand( 3 );
	for( int i=0 ; i < times ; ++i )
		rotate( true );
}


//	ubNQ̈ړ
void BlockGroup::move( vector<vector<BlockType>>& _gameFieldData ){
	//	
	if( isLand == true ){
		++landingTime;
		if( isFallingFast ){
			landingTime = BENCH_TIME + fallInterbal;
		}
	}

	//	ϐp
		++time;
		Liner2<int> gameArea;
		gameArea.x = _gameFieldData[0].size();
		gameArea.y = _gameFieldData.size();

	//	L[ɂړ,]
	KeyUpdate( keyState );
	//	Eړ
	if( blocks.at(1).canGoRight( _gameFieldData ) && blocks.at(2).canGoRight( _gameFieldData ) && isFallingFast == false ){
		if( keyState[ KEY_INPUT_RIGHT ] == 1 )
			++(location.x);
		else if( keyState[ KEY_INPUT_RIGHT ] >= SPEEDY_MOVE_START && keyState[ KEY_INPUT_RIGHT ] % SPEEDY_MOVE_INTERVAL == 1 )
			++(location.x);
	}
	//	ړ
	if( blocks.at(0).canGoLeft( _gameFieldData ) && blocks.at(3).canGoLeft( _gameFieldData ) && isFallingFast == false ){
		if( keyState[ KEY_INPUT_LEFT ] == 1  )
			--(location.x);	
		else if( keyState[ KEY_INPUT_LEFT ] >= SPEEDY_MOVE_START && keyState[ KEY_INPUT_LEFT ] % SPEEDY_MOVE_INTERVAL == 1 )
			--(location.x);
	}
	//	
	if( keyState[ KEY_INPUT_DOWN ] == 1 ){
		isFallingFast = true;
	}
	//	]
	if( keyState[ KEY_INPUT_Z ] == 1 )
		rotate( true );
	if( keyState[ KEY_INPUT_X ] == 1 )
		rotate( false );

	//	ڒnEړ
	assign( _gameFieldData );
	if( blocks.at(2).checkLanding( _gameFieldData ) || blocks.at(3).checkLanding( _gameFieldData ) ){
		isLand = true;
	}
	else{
		isLand = false;
		landingTime = 0;
	}
	if( isLand == false ){
		//	ʂɗ
		if( time % fallInterbal == 1 && time >= BENCH_TIME )
			++(location.y);
		//	
		if( isFallingFast && time % FAST_FALL_INTERBAL == 0 ){ 
			++(location.y);
		}
	}

	//	̃ubNJn_ݒ
	if( location.y == 0 ){
		startLocation.x = location.x;
	}

	/*	͈͊O␳
	if( location.x < 0 )
		location.x = 0;
	if( location.x > gameArea.x - 2 )
		location.x = gameArea.x - 2;*/

	
/*	if( location.y >= gameArea.y - 2 )
		isLand = true;
	else
		isLand = false;*/
}


//	ubNQ̔zu
void BlockGroup::assign( vector<vector<BlockType>>& _fieldData ){
	Liner2<int> loc ; loc.x = 1 ; loc.y = 1;
	blocks[0].myLocation = location;
	blocks[1].myLocation = location ; ++(blocks[1].myLocation.x) ;
	blocks[2].myLocation = location ; blocks[2].myLocation += loc;
	blocks[3].myLocation = location ; ++(blocks[3].myLocation.y);
	for( int i=0 ; i < GROUP_NUMBER_OF_ELEMENT ; ++i )
		blocks[i].assign( _fieldData );
}


//	ubNQ̉]
void BlockGroup::rotate( bool direction ){
	int times = 1;
	if( direction == false )
		times = 3;
	for( int t=0 ; t < times ; ++t ){
		BlockType tmp = blocks[0].myType;
		for( int i=1 ; i < GROUP_NUMBER_OF_ELEMENT ; ++i )
			blocks[ i-1 ].myType = blocks[i].myType;
		blocks[ GROUP_NUMBER_OF_ELEMENT - 1 ].myType = tmp;
	}
}


//	ڒnubNQԂ
vector<Block> BlockGroup::getLand(){
	vector<Block> ret;
	
	//	ǂ̂炢ڒnΒnƂ݂ȂH
	int maxLandingTime;
	if( location.y == 0 ) { maxLandingTime = BENCH_TIME; }
	else { maxLandingTime = LANDING_TIME; }

	//	n
	if( isLand == false || landingTime <= maxLandingTime )
		ret.resize(0);
	else{

		//	ʂɐڒn炻̃ubNԂ
		ret.reserve( GROUP_NUMBER_OF_ELEMENT );
		for( int i=0 ; i < GROUP_NUMBER_OF_ELEMENT ; ++i ){
			ret.push_back( blocks.at(i) );
		}
		//	̃ubNo
		PlaySoundMem( landSoundHandle , DX_PLAYTYPE_BACK , true );
		set( getRandomGroupPattern() , DEFAULT_FALL_INTERBAL );
	}
	return ret;
}


//	O[o֐
//	ubNQ̃p^[ԍ_ɕԂBm␳ρB
int getRandomGroupPattern(){
	int Sn = 15;
	int x = GetRand( Sn );
	if( 0 <= x && x <= 3 ) return 0;
	if( x == 4 ) return 1;
	if( x == 5 ) return 2;
	if( x == 6 || x == 7 ) return 3;
	if( 8 <= x && x <= 11 ) return 4;
	if( 12 <= x && x <= 15 ) return 5;
	return -1;
}
