#include "field.h"

//	tB[h
void Field::initialize( const int& graphHandle , const Liner2<int>& area , const Liner2<int>& coordinates ){

	//	
	myArea = area;
	myCoordinates = coordinates;
	GetGraphSize( graphHandle , &myCellSize.x , &myCellSize.y );
	myCells.resize( myArea.x * myArea.y );

	//	}Xڂ̍쐬
	Liner2<int> co;
	for( int i=0 ; i < area.x * area.y ; ++i ){
		co.x = ( i % myArea.x ) * myCellSize.x + myCoordinates.x;
		co.y = i / myArea.x * myCellSize.y + myCoordinates.y;
		myCells[i].setCoordinates( co );
		myCells[i].setGraphHandle( graphHandle );
	}
}


//	`
void Field::draw(){
	for( int i=0 ; i < myArea.x * myArea.y ; ++i )
		myCells[i].draw();
}


//	1}XύX
void Field::setGraphHandle( const Liner2<int>& location , const int& graphHandle ){
	myCells[ locToNum( location ) ].setGraphHandle( graphHandle );
}


//	}X̃nhԂ
int Field::getGraphHandle( const Liner2<int>& location ){
	return myCells[ locToNum( location ) ].getGraphHandle();
}


//	}X̍WԂ
Liner2<int> Field::coordinates( const Liner2<int>& location ){
	return myCells[ locToNum( location ) ].getCoordinates();
}

Liner2<int> Field::getCellSize(){
	return myCellSize;
}

//	܂Ƃ߂ĕύX
void Field::changeField( const vector<vector<int>>& graphHandles ){
	Liner2<int> loc;
	for( int i=0 ; i < myArea.y ; ++i ){
		for( int j=0 ; j < myArea.x ; ++j ){
			loc.x = j;
			loc.y = i;
			myCells[ locToNum( loc ) ].setGraphHandle( graphHandles.at(i).at(j) );
		}
	}
}


//	ʒuԍ
int Field::locToNum( const Liner2<int>& loc ){
	return loc.y * myArea.x + loc.x;
}