////////////////////////////////////////////////////////////////////////
//	Vanishing Block	C֐

#include "DxLib.h"
#include "FallingBlock.h"
#include "title.h"
#include "gameOver.h"
#include "cleared.h"
#include "key.h"
#define DEBUG_MODE 0
#define BACK_GRAPH "Data/gameBackGraph.jpg"

//	ʏ탂[h
#if ( ! DEBUG_MODE )
	///	C֐
int WINAPI WinMain( HINSTANCE, HINSTANCE, LPSTR, int ){

	//	{ϐ
	enum GameMode { TITLE , GAME , GAME_OVER , CLEAR , count };
	GameMode gameMode = TITLE;
	int keyState[256];

	//	DxLib
	SetWindowText("Energetic Blocks"), ChangeWindowMode(true), DxLib_Init(), SetDrawScreen( DX_SCREEN_BACK );

	//	^CgEQ[I[o[ENA
	Title title;
	GameOver gameOver;
	Cleared cleared;
	title.initialize();
	gameOver.initialize();
	cleared.initialize();

	//	Q[tB[h
	vector<int> blockGraphHandles;
	//blockGraphHandles.push_back(LoadGraph( "Data/blockfield({c).bmp" ));	//24*24hbg
	blockGraphHandles.push_back(LoadGraph( "Data/blockfield.png" ));
	blockGraphHandles.push_back(LoadGraph( "Data/bench.png" ));

	//blockGraphHandles.push_back(LoadGraph( "Data/whiteblock.bmp" ));
	//blockGraphHandles.push_back(LoadGraph( "Data/blueblock.bmp" ));
	
	blockGraphHandles.push_back(LoadGraph( "Data/shiroblock3.png" ));
	blockGraphHandles.push_back(LoadGraph( "Data/aoblock4.png" ));
	//blockGraphHandles.push_back(LoadGraph( "Data/siroblock.png" ));
	//blockGraphHandles.push_back(LoadGraph( "Data/aoblock2.png" ));
	blockGraphHandles.push_back(LoadGraph( "Data/squareWhite.bmp" ));
	blockGraphHandles.push_back(LoadGraph( "Data/squareBlue.bmp" ));

	blockGraphHandles.push_back(LoadGraph( "Data/timeline.bmp" ));
	FallingBlock mainField;
	Liner2<int> area; area.x = 16 ; area.y = 12 ;
	Liner2<int> coordinates ; coordinates.x = 20 ; coordinates.y = 110;
	mainField.initialize( area , coordinates , blockGraphHandles );
	mainField.setBackGraph( LoadGraph( BACK_GRAPH ) );
	InitSoundMem();

	
	///////////////////////////////////////////////////////////
	//	C[v
	while( ScreenFlip()==0 && ProcessMessage()==0 && ClearDrawScreen()==0 && KeyUpdate( keyState )==0  ){
		//	^Cg
		if( gameMode == TITLE ){
			title.draw();
			if( title.isEnd() ){
				gameMode = GAME;
				gameOver.initialize();
				cleared.initialize();
				 mainField.initialize( area, coordinates , blockGraphHandles );
				 mainField.setBackGraph( LoadGraph(BACK_GRAPH) );
			}
		}
		//	Q[[h
		if( gameMode == GAME ){
			mainField.update();
			mainField.draw();
			if( mainField.checkGameOver() ){ gameMode = GAME_OVER; }
			if( mainField.isCleared() ){ gameMode = CLEAR; }
		}
		//	Q[I[o[
		if( gameMode == GAME_OVER ){
			mainField.draw();
			gameOver.draw();
			if( gameOver.isEnd() ){
				gameMode = TITLE;
			}
		}
		//	NA
		if( gameMode == CLEAR ){
			mainField.draw();
			cleared.draw();
			if( cleared.isEnd() ){ gameMode = TITLE; }
		}
	}
	//	[vI
	//////////////////////////////////////////////////////////
	return 0;
}

#endif

//fobO[h
#if( DEBUG_MODE )

#include "drawableGroup.h"
#include "progressBar.h"

///	C֐
int WINAPI WinMain( HINSTANCE, HINSTANCE, LPSTR, int ){

	//
	SetWindowText("Vanishing Block"), ChangeWindowMode(true), DxLib_Init(), SetDrawScreen( DX_SCREEN_BACK );
	int keyState[256];

	ProgressBar progress;
	Liner2<int> progressSize( 100 , 30 );
	progress.initialize( "Data/blueBlock.bmp" , "Data/whiteBlock.bmp" , progressSize );
	progress.setCoordinates( 50,50 );
	int cnt=0;

	//C[v
	while( ScreenFlip()==0 && ProcessMessage()==0 && ClearDrawScreen()==0 && KeyUpdate( keyState )==0  ){
		++cnt;
		progress.setValue( cnt%100 , 100 );
		progress.draw();
	}
	//[vI
}
#endif