#include "piledBlock.h"

//	ςubNQ̏
void PiledBlock::initialize( const Liner2<int>& _area ){

	//	ϐp
	vanishSoundHandle = LoadSoundMem( "Data/vanish.wav" );
	squareSoundHandle = LoadSoundMem( "Data/square.mp3" );
	gravityInterbal = FAST_FALL_INTERBAL;
	gravityCounter = 0;
	isInGameOver = false;
	piledFieldData.clear();
	blocks.clear();

	//	ςf[^̏
	int x = _area.x , y = _area.y;
	initializeVector2( piledFieldData , y , x );
}


//	ubNQςf[^쐬
void PiledBlock::blocksToFieldData(){
	allTheSame( piledFieldData , -1 );
	int blk = blocks.size();
	int x,y;
	for( int i=0 ; i < blk ; ++i ){
		x = blocks.at(i).myLocation.x;
		y = blocks.at(i).myLocation.y;
		piledFieldData.at(y).at(x) = i;
	}
}


//	lp`
void PiledBlock::createSquare( vector<Block*>& _square ){
	bool newSquareExist = false;
	for( int i=0 ; i < 4 ; ++i ){
		if( _square.at(i)->myType == BLOCK_A ) {
			_square.at(i)->myType = SQUARE_A;
			newSquareExist = true;
		}
		if( _square.at(i)->myType == BLOCK_B ){
			_square.at(i)->myType = SQUARE_B;
			newSquareExist = true;
		}
	}
	if( newSquareExist ){
		PlaySoundMem( squareSoundHandle , DX_PLAYTYPE_BACK , true );
	}
}


//	ςubNQɃubNǉ
int PiledBlock::add( const vector<Block>& _newBlocks ){
	if( _newBlocks.size() == 0 ) return 0;

	int blockNumber = _newBlocks.size();
	for( int i=0 ; i < blockNumber ; ++i )
		blocks.push_back( _newBlocks.at(i) );
	return 1;
}


//	ςubNQtB[hf[^ɔzu
void PiledBlock::assign( vector<vector<BlockType>>& _fieldData ){
	int blockNumber = blocks.size();
	for( int i=0 ; i < blockNumber ; ++i ){
		blocks.at(i).assign( _fieldData );
	}
}


//	d͂
int PiledBlock::gravity(){

	//	
	int ret = 0;
	if( gravityCounter++ % gravityInterbal == 0 ){
		int blk = blocks.size();
		blocksToFieldData();

		//	ubNɑ΂Ẵ[v
		for( int i = blk-1 ; i >= 0 ; --i ){

			//	ubN̉܂Ō郋[v
			int h = blocks.at(i).myLocation.y + 1;
			int x = blocks.at(i).myLocation.x;
			int yMax = piledFieldData.size();
			int num;
			for( ; h < yMax ; ++h ){	
				num = piledFieldData.at(h).at(x);

				//	󔒂Η
				if( num == -1 ){
					++(blocks.at(i).myLocation.y);
					++ret;
				break;
				}
			}
		}
		//	㏈
		if( gravityCounter > 99999 ) gravityCounter = 0;
	}
	else ret = -1;
	return ret;
}


//	
void PiledBlock::changeSquare( Liner2<int>& _deletedLocation ){

	//	ϐp
	blocksToFieldData();
	Liner2<int> area;
	area.x = piledFieldData.at(0).size();
	area.y = piledFieldData.size();
	Block *upToFocus , *leftToFocus , *leftUpToFocus;
	vector<Block*> blocksSearchingFor;

	//	lp`̒T
	for( int i=0 ; i < area.y ; ++i ){
		for( int j=0 ; j < area.x ; ++j ){
			//	
			int num[4];		//	ׂubN̔ԍ
			int cnt;		//	ėpJE^
			bool areMakingSquare = true;	//	lp``邩
			num[0] = piledFieldData.at(i).at(j);
			if( num[0] == -1 ) continue;
			Block *focus = &blocks.at( num[0] );
			blocksSearchingFor.clear();
			blocksSearchingFor.reserve( 4 );
			blocksSearchingFor.push_back( focus );
			int fcx = focus->myLocation.x;
			int fcy = focus->myLocation.y;
			//	͎lp`
			if( fcy != 0 && fcx != 0 ){
				//	lp`݂ȂPF󔒂
				num[1] = piledFieldData.at(i-1).at(j);
				num[2] = piledFieldData.at(i).at(j-1);
				num[3] = piledFieldData.at(i-1).at(j-1);
				for ( cnt=0 ; cnt < 4 ; ++cnt ){
					if( num[cnt] == -1 ){
						areMakingSquare = false;
						break;
					}
				}
				//	lp`݂ȂQFFႤ
				if( areMakingSquare ){
					upToFocus = &blocks.at( num[1] );
					leftToFocus = &blocks.at( num[2] );
					leftUpToFocus = &blocks.at( num[3] );
					blocksSearchingFor.push_back( upToFocus );
					blocksSearchingFor.push_back( leftToFocus );
					blocksSearchingFor.push_back( leftUpToFocus );
					for( cnt=0 ; cnt < 4 ; ++cnt ){
						if( ! focus->isSameColorAs( *blocksSearchingFor.at(cnt) ) ){
							areMakingSquare = false;
							break;
						}
					}
				}
					//	lp`Ȃlp`^CvɕύX
				if( areMakingSquare )
					createSquare( blocksSearchingFor );
			}
		}
	}
}


//lp`肳ꂽubN^CC̈ʒuɉď
int PiledBlock::erase( int _timelineLocationX ){
	blocksToFieldData();
	int vanishedNum = 0;
	int height = piledFieldData.size();
	int width = piledFieldData.at(0).size();
	//	^CC̉EɎlp`̈ꕔcĂ܂Ȃ
	bool squareOnTheRight = false;
	if( _timelineLocationX != width-1 ){
		for( int i=0 ; i < height ; ++i ){
			int n = piledFieldData.at( i ).at( _timelineLocationX + 1 );
			if( n == -1 ){ continue; }
			BlockType t = blocks.at( n ).myType;
			if( t == SQUARE_A || t == SQUARE_B ){
				squareOnTheRight = true;
				break;
			}
		}
	}

	if( ! squareOnTheRight ){
		//	for
		for( int j = _timelineLocationX ;  j >= 0 ; --j ){
			bool isSquareLest = false;					//	A̎lp`pĂ邩
			for( int i=0 ; i < height ; ++i ){
				int n  = piledFieldData.at( i ).at( j );
				if( n == -1 ) { continue; }
				BlockType t = blocks.at( n ).myType;
				if( t == SQUARE_A || t == SQUARE_B ){
					isSquareLest = true;
					auto itr = blocks.begin();
					blocks.erase( itr + n );
					blocksToFieldData();
					++vanishedNum;
				}
			}
			if( ! isSquareLest ) { break; }
		}
	}
	if( vanishedNum > 0 ){
		PlaySoundMem( vanishSoundHandle , DX_PLAYTYPE_BACK , true );
	}
	return vanishedNum;
}


//	XV
void PiledBlock::update(){
	//	d͂
	if( gravity() == 0 && ! isInGameOver ){
		//	
		Liner2<int> deletedLocation;
		changeSquare( deletedLocation );
		}
}


//	Q[I[o[ȂtrueԂ
bool PiledBlock::checkGameOver(){
	
	//ɂ͂ݏoubNB4ŃQ[I[o[
	int vanished = 0;
	for( int i=0 ; i < int(blocks.size()) ; ++i ){
		if( blocks.at(i).myLocation.y < BENCH_HEIGHT ){
			vector<Block>::iterator itr = blocks.begin();
			blocks.erase( itr + i );
			++ vanished;
			--i;
		}
	}
	if( vanished >= 4 ){
		isInGameOver = true;
	}

	return isInGameOver;
}


//wsɎlp`ubN邩
bool PiledBlock::haveSquareInLine( int _line ){
	bool exist = false;
	int h = piledFieldData.size();
	for( int i=0 ; i < h ; ++i ){
		int blockNum = piledFieldData.at(i).at(_line);
		if( blockNum != -1 &&
			(blocks.at( blockNum ).myType == SQUARE_A ||
			 blocks.at( blockNum ).myType == SQUARE_B
			)){
				exist = true;
				break;
		}
	}
	return exist;
}

