#pragma once
#include "ProgressBar.h"
#include <iostream>
#define DIGIT_MAX 4
#define SECTION_Y_DIV 5
#define SECTION_X_DIV 6
#define SECTION_Y(secNum) (coordinates.y + section.y * secNum)
#define SECTION_X(secNum) (coordinates.x + section.x * secNum)
#define BAR_HEIGHT 7
#define SLASH_WIDTH 9
enum GRAPH_ELEMENT{ TIME_GRAPH , DISTANCE_GRAPH , BLOCKS_GRAPH , EFFICIENCY_GRAPH , graphCount };
enum BAR_ELEMENT{ TIME_BAR , DISTANCE_BAR , barCount };
enum STRING_ELEMENT{ TIME_VALUE = 0 , DISTANCE_VALUE , BLOCKS_VALUE , EFFICIENCY_VALUE , TIME_MAX_VALUE , DISTANCE_MAX_VALUE , TIME_STRING , DISTANCE_STRING , BLOCKS_STRING , EFFICIENCY_STRING , SLASH_T , SLASH_D , stringCount , INFO_NUM = 6 };

class Status : public DrawableGroup {
protected:
//	int time , distance , blocks , efficiency;
	Liner2<int> size;
	vector<GraphForm> graphElements;
	vector<ProgressBar> barElements;
	vector<StringForm> stringElements;
public:

	//ftHg
	Status(){
		setCoordinates( 0,0 );
	}

	//(\vf)
	void initialize( const Liner2<int>& _coordinates , const Liner2<int>& _size ){

		//bϐ
		size = _size;
		setCoordinates( _coordinates );

		//
		graphElements.assign( int(graphCount), *new GraphForm );
		barElements.assign( int(barCount) , *new ProgressBar );
		stringElements.assign( int(stringCount) , *new StringForm );
		for( int i=0 ; i < graphCount ; ++i ){
			add( graphElements.at(i) );
		}
		for( int i=0 ; i < barCount ; ++i ){
			add( barElements.at(i) );
		}
		for( int i=0 ; i < stringCount ; ++i ){
			add( stringElements.at(i) );
		}
		
		//zu(fUC)
		Liner2<int> barSize( _size.x , BAR_HEIGHT );
		Liner2<int> section( size.x / SECTION_X_DIV ,  size.y / SECTION_Y_DIV );	//W𐔕1ZNV
		graphElements.at(TIME_GRAPH).set("Data/graphTime.bmp");
		graphElements.at(TIME_GRAPH).setCoordinates( SECTION_X(0) , SECTION_Y(0) );
		graphElements.at(DISTANCE_GRAPH).set("Data/graphDistance.bmp");
		graphElements.at(DISTANCE_GRAPH).setCoordinates( SECTION_X(0) , SECTION_Y(1) );
		graphElements.at(BLOCKS_GRAPH).set("Data/graphBlocks.bmp");
		graphElements.at(BLOCKS_GRAPH).setCoordinates( SECTION_X(0) , SECTION_Y(3) );
		graphElements.at(EFFICIENCY_GRAPH).set("Data/graphEfficiency.bmp");
		graphElements.at(EFFICIENCY_GRAPH).setCoordinates( SECTION_X(0) , SECTION_Y(4) );
		barElements.at(TIME_BAR).initialize( "Data/blueBlock.bmp" , "Data/whiteBlock.bmp" , barSize );
		barElements.at(TIME_BAR).setCoordinates( SECTION_X(0) , SECTION_Y(0)+30 );
		barElements.at(DISTANCE_BAR).initialize( "Data/blueBlock.bmp" , "Data/whiteBlock.bmp" , barSize );
		barElements.at(DISTANCE_BAR).setCoordinates( SECTION_X(0) , SECTION_Y(1)+30 );
		stringElements.at(TIME_STRING).setString( "TIME" );
		stringElements.at(TIME_STRING).setCoordinates( SECTION_X(1) , SECTION_Y(0) );
		stringElements.at(TIME_VALUE).setCoordinates( SECTION_X(4) , SECTION_Y(0) );
		stringElements.at(TIME_VALUE).setColor( 255,242,0 );
		stringElements.at(SLASH_T).setString( "/" );
		stringElements.at(SLASH_T).setCoordinates( SECTION_X(5) , SECTION_Y(0) );
		stringElements.at(TIME_MAX_VALUE).setCoordinates( SECTION_X(5)+SLASH_WIDTH , SECTION_Y(0) );
		stringElements.at(DISTANCE_STRING).setString( "DISTANCE" );
		stringElements.at(DISTANCE_VALUE).setCoordinates( SECTION_X(4) , SECTION_Y(1) );
		stringElements.at(DISTANCE_VALUE).setColor( 255,242,0 );
		stringElements.at(SLASH_D).setString( "/" );
		stringElements.at(SLASH_D).setCoordinates( SECTION_X(5) , SECTION_Y(1) );
		stringElements.at(DISTANCE_MAX_VALUE).setCoordinates( SECTION_X(5)+SLASH_WIDTH , SECTION_Y(1) );
		stringElements.at(DISTANCE_STRING).setCoordinates( SECTION_X(1) , SECTION_Y(1) );
		stringElements.at(BLOCKS_STRING).setString( "BLOCKS" );
		stringElements.at(BLOCKS_VALUE).setCoordinates( SECTION_X(5) , SECTION_Y(3) );
		stringElements.at(BLOCKS_STRING).setCoordinates( SECTION_X(1) , SECTION_Y(3) );
		stringElements.at(EFFICIENCY_STRING).setString( "EFFICIENCY" );
		stringElements.at(EFFICIENCY_VALUE).setCoordinates( SECTION_X(5) , SECTION_Y(4) ); 
		stringElements.at(EFFICIENCY_STRING).setCoordinates( SECTION_X(1) , SECTION_Y(4) );
		
		//ftHglZbg
		vector<int> defaultInfo;
		for( int i=0 ; i < INFO_NUM ; ++i ){
			defaultInfo.push_back(1);
		}
		setInfo( defaultInfo );
	}

	//ݒ ( enum STRING_ELEMENT ̏)
	void setInfo( const vector<int>& _info ){
		for( int i=0 ; i < INFO_NUM ; ++i ){
			char buf[ DIGIT_MAX ];
			_itoa_s( _info.at(i) , buf , DIGIT_MAX , 10 );
			stringElements.at(i).setString(buf);
		}
		barElements.at( TIME_BAR ).setValue( _info.at(TIME_VALUE) , _info.at(TIME_MAX_VALUE) );
		barElements.at( DISTANCE_BAR ).setValue( _info.at(DISTANCE_VALUE) , _info.at(DISTANCE_MAX_VALUE) );
	}
};